#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#define CHUNK 512
char BREPATH[80];
#define version "2.5"

/*************  define BRE packet header type ******************/
typedef struct{
	 char fn[13];       /* filename 8.3 and terminator */
	 long size;         /* size of file being sent */
	 char resbyte[32];  /* reserved  all zeroes */
}brepkt;

/*************** WWIV message header type *********************/
typedef struct {
		  unsigned short  tosys,          /* destination system */
								touser,         /* destination user */
								fromsys,        /* originating system */
								fromuser;       /* originating user */
		  unsigned short  main_type,      /* main message type */
								minor_type;     /* minor message type */
		  unsigned short  list_len;       /* # of entries in system list */
		  unsigned long   daten;          /* date/time sent */
		  unsigned long   length;         /* # of bytes of msg after header */
		  unsigned short  method;         /* method of compression */
} net_header_rec;

typedef struct
{
	unsigned char type;						/* type of network */
	char name[16];								/* network name */
	char dir[69];									/* directory for net data */
	unsigned short sysnum;				/* system number */
	void far *con;								/* ptr to callout data */
	void far *ncn;								/* ptr to contact info */
	int num_con;									/* number in array */
	int num_ncn;									/* number in array */
} net_networks_rec;

int get_net_info(int num, net_networks_rec * rec);


int main(int argc, char *argv[])
{
long numchar;           // an integer variable  (16 bits)
char buf[CHUNK];
FILE *fig,*foo;  // two pointers to FILE structures (defined in stdio.h)
FILE *log;
int netnum;
time_t now;
struct tm *tmnow;
char brepath[80];// an array of 80 chars
brepkt header;
net_header_rec wwiv;
net_networks_rec thisnet;

printf("Executing BR %s\n",version);

/******  read the header *************/
if(argc < 2)
  {
  printf("BR should be called by network2.exe\n");
  return -1;
  }

log=fopen("bresnd.log","at");

now=time(NULL);
tmnow=localtime(&now);
strftime(brepath,80,"** Incomming BRE packet at %X on %x **\n",tmnow);
fprintf(log,brepath);

fig=fopen("bresnd.cfg","rt");
if(!fig)
	{
	fprintf(log,"bresnd.cfg not found.  Terminating...\n\n");
	fclose(log);
	printf("bresnd.cfg not found.  Terminating...\n");
	return -2;
	}

fgets(BREPATH,60,fig);
BREPATH[strlen(BREPATH)-1] = '\0';   // strip the <CR>
fclose(fig);



// get info for current network from networks.dat, store in "thisnet"
netnum = atoi(&argv[2][1]);     // skip the decimal point
if (!get_net_info(netnum, &thisnet))
	{
	fprintf(log, "Unable to open network data file - terminating !\n\n");
	printf("\nUnable to open network data file !\n");
	fclose(log);
	return -2;
	}

printf("BR is processing %s packet %s\n",thisnet.name,argv[1]);
fprintf(log,"Processing %s packet %s\n",thisnet.name,argv[1]);
fig=fopen(argv[1],"rb");                 // open the temp file network2 made
if(fig==NULL)
	{
	fprintf(log,"Couldn't read %s !  Terminating !\n\n",argv[1]);
	fclose(log);
	return -3;
	}
while(fread(&wwiv,sizeof(net_header_rec),1,fig))
	{
	fprintf(log,"Packet to %d@%d, from %d@%d, %ld bytes\n",wwiv.touser,
		 wwiv.tosys,wwiv.fromuser,wwiv.fromsys,wwiv.length);
	fread(&header,sizeof(brepkt),1,fig);  // and read the header

	strcpy(brepath,BREPATH);
	strcat(brepath,header.fn);
	fprintf(log,"Received %s\n",header.fn);
	foo = fopen(brepath,"wb"); // open file
	if(foo == NULL)
	  {
		fprintf(log,"Couldn't create %s !  Terminating !\n\n",brepath);
		fclose(fig);
		fclose(log);
		return -4;
	  }
	numchar = header.size;
	while(numchar > CHUNK)
	  {
	  fread(buf,CHUNK,1,fig);
	  fwrite(buf,CHUNK,1,foo); //write 512 bytes to output file
	  numchar -= CHUNK;
	  }
	fread(buf,(unsigned)numchar,1,fig);
	fwrite(buf,(unsigned)numchar,1,foo); // write the rest
	fclose(foo);
	}
fclose(fig);             // close the input file
fprintf(log,"** Done ! **\n\n");
fclose(log);
return 0;
}


int get_net_info(int num, net_networks_rec * rec)
{
	FILE *in;
	in = fopen("data/networks.dat", "rb");
	if (!in)
		return 0;
	fseek(in, (long) (num * sizeof(net_networks_rec)), SEEK_SET);
	fread(rec, sizeof(net_networks_rec), 1, in);
	fclose(in);
	return 1;
}

