#include <stdio.h>   // file i/o prototypes & structures
#include <dir.h>     // prototypes & structures for file find functions
#include <time.h>    // protos & structs for time functions
#include <string.h>
#include <stdlib.h>
#define CHUNK 512   // disk buffer                                                                  // buffer size
#define version "2.6"
/*************  define BRE packet header type ******************/
typedef struct{
	 char fn[13];       /* filename 8.3 and terminator */
	 long size;         /* size of file being sent */
	 char resbyte[32];  /* reserved  all zeroes */
}brepkt;

/***********  define FIDOnet message header type ****************/
typedef struct  {
	  char fromUserName[36],
	  toUserName[36],
	  subject[72],
	  dateTime[20];
	  int timesRead,
	  destNode,
	  orgNode,
	  cost,
	  orgNet,
	  destNet,
	  destZone,
	  orgZone,
	  destPoint,
	  orgPoint,
	  replyTo,
	  Attribute,
	  nextReply;
}fidomsg;

/*************** WWIV message header type *********************/
typedef struct {
		  unsigned short  tosys,          /* destination system */
								touser,         /* destination user */
								fromsys,        /* originating system */
								fromuser;       /* originating user */
		  unsigned short  main_type,      /* main message type */
								minor_type;     /* minor message type */
		  unsigned short  list_len;       /* # of entries in system list */
		  unsigned long   daten;          /* date/time sent */
		  unsigned long   length;         /* # of bytes of msg after header */
		  unsigned short  method;         /* method of compression */
} net_header_rec;

FILE *log;

int breout(int dest,int net, char *ofile);
int findalias(int *dest, int *net);
char BREPATH[80];
char NETPATH[10][80];  // up to 10 networks, now !
char mailname[90];
fidomsg bar;        // Fido message header


int main()
{
struct ffblk fb;    // file find structure
FILE *in;           // file handle
int i=0;
char bpath[80];     // search string
char cpath[80];     // fido message filename
struct tm *tmnow;
int foo,res;
time_t now;

printf("Executing BS %s\n",version);
log=fopen("bresnd.log","at");
now=time(NULL);
tmnow=localtime(&now);
strftime(bpath,80,"** Executing BS 2.6 at %X on %x **\n",tmnow);
fprintf(log,bpath);
in = fopen("bresnd.cfg","rt");
if(!in)
	{
	printf("Unable to open BRESND.CFG !\n");
	fprintf(log,"Unable to open BRESND.CFG !  Terminating.\n\n");
	fclose(log);
	return -1;
	}

fgets(bpath,60,in) ;     // path for incomming, not used
fgets(BREPATH,60,in);    // path for outgoing
if(strlen(BREPATH) < 2)
	{
	printf("I find your configuration file a tad confusing...\n");
	fclose(in);
	fprintf(log,"invalid bresnd.cfg ! Terminating !\n");
	fclose(log);
	return -2;
	}
BREPATH[strlen(BREPATH)-1] = '\0';
strcpy(bpath,BREPATH);            // path to bre output files
strcat(bpath,"*.msg");            // any fido message file


while(fgets(NETPATH[i],60,in))    // path for network #1
  {
  NETPATH[i][strlen(NETPATH[i])-1] = '\0';
  i++;
  if(i>9)
	 {
	 fprintf(log,"Network number exceeded - %s ignored.\n",NETPATH[i]);
	 break;
	 }
	}

foo=findfirst(bpath,&fb,0);       // do the search
while(foo==0)                     // findfirst returns 0 on success
	{
	strcpy(cpath,BREPATH);         // build a pathname
	strcat(cpath,fb.ff_name);
	fprintf(log,"Processing %s\n",fb.ff_name);
	in=fopen(cpath,"rb");          // open the .msg file
	if(in == NULL)
	  {
	  fprintf(log,"unable to open %s ! Terminating\n\n",fb.ff_name);
	  fclose(log);
	  return -3;
	  }
	fread(&bar,sizeof(fidomsg),1,in);  // read in the fido message header
	fprintf(log,"Sending %s to %d/%d\n",bar.subject,
		bar.destNet,bar.destNode);
	 printf("Sending %s to %d/%d\n",bar.subject,
		bar.destNet,bar.destNode);
	res= breout(bar.destNode,bar.destNet,bar.subject);// breout sends the file
	fclose(in);
/*
	if(res < 0)
		 {
		 fclose(log);
		return -3;
		}
*/
	unlink(cpath);
	foo=findnext(&fb);             // findnext returns 0 on success...
	}
// now do cleanup...
strcpy(bpath,BREPATH);          // path to bre output files
strcat(bpath,"*.*");            // any  file in bre outgoing directory
foo=findfirst(bpath,&fb,0);       // do the search
while(foo==0)                     // findfirst returns 0 on success
	{
	strcpy(cpath,BREPATH);         // build a pathname
	strcat(cpath,fb.ff_name);
	printf("Deleting %s\n",fb.ff_name);
	unlink(cpath);
	foo=findnext(&fb);
	}
fprintf(log,"*********  Done ! ********\n\n");
fclose(log);
return 0;
}


int breout(int dest,int net, char *ofile)
{
FILE *foo;
FILE *mail;
char buf[CHUNK];
net_header_rec h;
unsigned long numchar;
struct ffblk  tmp;
brepkt pkt;
time_t l;
if(NETPATH[net-1][0]=='\0')
	{
	printf("Network #%d not defined !\n",net);
	fprintf(log,"Network #%d not defined !\n",net);
	return -1;
	}

//Make sure that network exists...
strcpy(mailname,NETPATH[net-1]);
strcat(mailname,"callout.net");
if(findfirst(mailname,&tmp,0))   // net doesn't exist !
	if(!findalias(&dest, &net))    // couldn't find an alias !
	  {
	  fprintf(log,"No alias found for %d/%d - contact your league person\n",
		 net,dest);
	  return -5;
	  }
if(findfirst(ofile,&tmp,0))
  {
  fprintf(log,"Couldn't find %s !\n",ofile);
  return -2;
  }

strcpy(mailname,NETPATH[net-1]);
strcat(mailname,"p56.net");

memset(&pkt,0,sizeof(brepkt));            // initialize headers
memset(&h,0,sizeof(net_header_rec));

/****** setup the network packet header **********/
h.touser = 1;
h.tosys = dest;
h.fromsys = bar.orgNode;
h.fromuser = 1;
h.main_type=0x1b;        // new extern
h.minor_type=56;        // new type for bre
time(&l);
h.daten=l;
h.method = 0;
h.list_len =0;
h.length = tmp.ff_fsize+sizeof(brepkt);

/******** set up the bre header ************/

strcpy(pkt.fn,tmp.ff_name);        // filename
pkt.size=tmp.ff_fsize;

mail = fopen(mailname,"ab");
if(mail == NULL)
	{
	printf("Unable to open %s !\n",mailname);
	fprintf(log,"Unable to open %s !\n",mailname);
	 return -4;
	 }

foo = fopen(ofile,"rb");
if(foo == NULL)
	{
	printf("Unable to open %s !\n",ofile);
	fprintf(log,"Unable to open %s !\n",ofile);
	 fclose(mail);
	 return -5;
	 }

fwrite(&h,sizeof(net_header_rec),1,mail);
fwrite(&pkt,sizeof(brepkt),1,mail);

numchar = tmp.ff_fsize;
while(numchar > CHUNK)
  {
  fread(buf,CHUNK,1,foo);
  fwrite(buf,CHUNK,1,mail); //write 512 bytes to output file
  numchar -= CHUNK;
  }
fread(buf,(unsigned)numchar,1,foo);
fwrite(buf,(unsigned)numchar,1,mail); // write the rest
numchar=h.length+sizeof(net_header_rec);

fclose(foo);
fclose(mail);
printf("mailname = %s\n",mailname);
fprintf(log,"Wrote to %s, %d bytes\n",mailname,numchar);
return 0;
}




int findalias(int *dest, int *net)
{
FILE *aka;
char aliasline[80];
char matchline[8];
char *me,*you;
char pathname[80];
struct ffblk  tmp;
int n,d;

sprintf(matchline,"%d/%d",*net,*dest);
fprintf(log,"Not connected to %s, searching for alias...\n",matchline);
aka=fopen("alias.net","rt");
if(aka==NULL)
	 {
	 fprintf(log,"Unable to open alias.net !\n");
	 return 0;
	 }
while(fgets(aliasline,60,aka) != NULL)
	{
	if(strstr(aliasline,matchline)!=NULL)
		{
		 me=strtok(aliasline,",");
		 if(me)
			{
			while(me=strtok(NULL,","))
				{
				you=strtok(me,"/");
				n=atoi(you);
				you=strtok(NULL,"/");
				d=atoi(you);
				fprintf(log,"Trying alias %d/%d\n",n,d);
				strcpy(pathname,NETPATH[n-1]);
				strcat(pathname,"callout.net");
				if(findfirst(pathname,&tmp,0))   // net doesn't exist !
					;
				else
					{
					fprintf(log,"Using alias %d/%d \n",n,d);
					*net = n; *dest = d;
					fclose(aka);
					return 1;
					}
				}
			}
		 }
	  }
fclose(aka);
return 0;
}


